LeetCode Exercise In Java - Longest Substring Without Repeating Characters - FAST Solution

Поделиться
HTML-код
  • Опубликовано: 22 авг 2024

Комментарии • 181

  • @CodingWithJohn
    @CodingWithJohn  Год назад +15

    Thanks to Mailgun for sponsoring this video! Head to mailgun.com/john to try Mailgun free today.
    Looking forward to seeing how you guys make this solution even better!

    • @aryansanojraj6618
      @aryansanojraj6618 Год назад +1

      Can you let us know the compiler you use for the videos?

    • @ripanpramanick425
      @ripanpramanick425 Год назад +1

      Not able to understand how this algo will work for some string like "abcdcga" as we will keep our left pointer at first a and we will increment right pointer, at when right pointer at second c it will get repeated letter and will increment left pointer to b and in next iteration it will move to g and will register length of bcdcg but this substring is already having repeated character. Rather than incrementing left pointer by one we should increment it by lastCharOccuredIndex+1

    • @ZelenoJabko
      @ZelenoJabko 2 месяца назад

      The complexity of your first algorithm is n cubed, not n squared! There is one more loop hidden in String.indexOf, looking for a duplicate character.

  • @playtopgames3261
    @playtopgames3261 Год назад +69

    Best java chanel on RUclips

  • @nahomg6945
    @nahomg6945 Год назад +55

    You genuinely have one of the best programming explanation videos on this site, honestly. Funny, I was discussing learning about the Sliding Window algorithm to practice Leetcode questions with a friend yesterday, and lo and behold you've uploaded a great explanation literally 24hrs later, legendary! Could you please upload more Leetcode explanation questions? If not on RUclips, perhaps a course?

    • @Achraf_0101
      @Achraf_0101 4 месяца назад

      i already signed up in his course but it does not contain any exercises i wonder if there is another course where he solves problems

    • @joydeep_
      @joydeep_ 2 месяца назад

      Same feelings here, we need more leet code problems...

  • @vijal-patel
    @vijal-patel Год назад +25

    please keep doing these, your explanations are so much more in depth than other youtube channels

  • @jayshreebargohil
    @jayshreebargohil Год назад +13

    I had just solved this problem and found this video. You explained each solution and your approach in the best way. Your way to explaining make things crystal clear John !!

  • @claytonalmeida6046
    @claytonalmeida6046 Год назад +14

    Would love to watch a complete java dsa course from you

    • @jayshreebargohil
      @jayshreebargohil Год назад

      DSA would be more easy and interesting with John 😀

  • @thomas_m3092
    @thomas_m3092 Год назад +7

    John, you are a wizard. Everythings looks so logical and simple. Please make more videos like this.

  • @tund_101_hd9
    @tund_101_hd9 Год назад +5

    This is probably one of the best tutorials out there and i think RUclips is with me in this.❤️ I could you not, even though I have watched it already it is every time the first video in my recommended 😂
    Guess I'll watch it twice. Keep up the good work!

  • @tiagocarvalho4119
    @tiagocarvalho4119 Год назад +6

    You have to be careful when using a MAP to lookup something because, even though its O(1) in time complexity, there is a lot of overhead. Let's say that the constant time for a lookup in a MAP is always 500 nanoseconds, if the indexOf (that has a time complexity of O(n)) takes only 300 nanoseconds because it finds the answer in the first few characters, then the indexOf will perform better. This obviously can be measured and we can come up with some threshold that tells us what algorithm to use in each situation. My guess is that in the English language indexOf will always perform better because we are dealing with words that are small in size (there is always the repeating space character).

  • @yasasmaddumage
    @yasasmaddumage Год назад +5

    I love this series. Thank you...

  • @minakianrad812
    @minakianrad812 Год назад +3

    An excellent in-depth explanation of two approaches to solving this problem. Thank you very much, John.

  • @blairliu9058
    @blairliu9058 Год назад +5

    More leetcode videos plzzz! love this series.

  • @MTB_Bay_Area
    @MTB_Bay_Area Год назад +2

    For the brute force solution. I suggest checking if the max need to be updated in the "if contains part" that makes sure that we only do it right before we break. It is one time per substring. We fount a substring, now, let's check if it is better than the other we had so far. Second, I will suggest using HashSet instead of StringBuilder. HashSet has contains method and it is faster.

  • @rushio8673
    @rushio8673 Год назад +2

    Great job, please keep posting the leetcode solution videos in structural manner(for eg top 50 that includes most practices/datastructures) , this helps a lot in preparing for interviews.

  • @elizabeth00653
    @elizabeth00653 9 месяцев назад +1

    John I love your Java explanations, can you please add more leetcode to your channel or bootcamp? I would love to see more Java leetcode solution guides properly explained

  • @rahulg1715
    @rahulg1715 5 месяцев назад

    At 35:00 we should use indexOfFirstAppearenceInsubstring

  • @gauravmehta6831
    @gauravmehta6831 Месяц назад

    A unique way of explanation, clear concise.

  • @SimanAndGarfunkel
    @SimanAndGarfunkel 5 месяцев назад

    I love the final thoughts on the differences of performance between the 2 last algorithms, answered all the questions I had to myself. Thnak you!

  • @ronakpatel8441
    @ronakpatel8441 Год назад +2

    Hey John, I love all of your videos. Learning so many important skills. However, I have one suggestion, If you could make more of this type of problem-solving videos then it would be very helpful to the viewers as it will teach new programmers how to think of a solution to the given problem and how can we actually implement the solution using the programming language.
    By the way thanks again for all efforts that you put in to make this possible.
    Looking forward to seeing more problem-solving videos. Have a wonderful day.

  • @lanatimmo3686
    @lanatimmo3686 Год назад +4

    It's great! Please, do more Leetcode Exercise explanations!🙏

  • @shaileshsathe9779
    @shaileshsathe9779 Год назад

    Great and in-depth explanation for every approach. I really liked this video. I have found another better approach
    final int n = s.length();
    int len = 0;
    int [] repeat = new int[128];
    for (int c = 0, j = 0, i = 0; j < n; j++) {
    c = s.charAt(j);
    i = Math.max(repeat[c], i);
    len = Math.max(len, j - i +1);
    repeat[c] = j+1;
    }
    return len;
    I somewhat understood, but it would be better if you can explain. Thanks John and keep creating more videos for different problems.

  • @Michaelpschreib
    @Michaelpschreib 7 месяцев назад

    I appreciate that you go into the brute force solution and also the more clever solution. Thanks for these!!

  • @isaacwhiz
    @isaacwhiz Год назад

    You are really a coding geek. Even the concepts known, still visit them and keep something. Your explanations are far reaching. Thank you.

  • @SimoLPers
    @SimoLPers Год назад +1

    I'm currently just at the brute-force method in the video, but for the lookups I'd probably use a hashset.
    I would therefore prevent an O(n²) lookup.
    But the brute-force method was the first idea for me as well.

  • @liamoua9192
    @liamoua9192 Год назад

    John, you’ve helped me understand DS&A in Java better than before. The way you explained things are easy to understand and follow. I’m a visual learner and your explanations makes it easier for me visualize & understand. Thank you and please keep these leet code videos coming. Your other videos on Java has truly helped me understand Java so much more than my professors lol you are incredible in the work that you’re doing for me and many. We cannot thank you enough ❤ I appreciate you.

    • @CodingWithJohn
      @CodingWithJohn  Год назад

      Thanks so much for the very kind words!

    • @91-ritikjain36
      @91-ritikjain36 10 месяцев назад

      when we get full playlist of leetcode in java you are amazing i am from india @@CodingWithJohn

  • @germimonte
    @germimonte Год назад +8

    given that there's a finite and constant number of letters, you could probably replace the HashMap with a regular array for a negligible decrease in time and memory

    • @CodingWithJohn
      @CodingWithJohn  Год назад +6

      Yeah it could be the case that despite the technical time complexity being lower, because n will never be more than 50,000, simple sequential array searches might just be more performant

    • @cipherxen2
      @cipherxen2 Год назад +3

      @@CodingWithJohn you don't need array of 50000 elements, just 255 for ASCII characters

    • @bhaskarpurkayastha485
      @bhaskarpurkayastha485 Год назад

      @@cipherxen2 and a character can be found in this array in O(1) time by -
      int lastEncountered = charIndexes[currentChar]; Initialize charIndexes[255] with all -1;

  • @OsaetinEvbuoma
    @OsaetinEvbuoma Год назад +1

    Hi John. I previously implemented this solution (yours) using a while-loop (and using the map) instead of a for-loop and got similar runtime numbers to the last solution you found (6ms runtime). Not sure why that's the case. But yeah, the last solution, intuitively should be a worse runtime even though it seems like it performs better. It's also a clever solution too. Nice work!

  • @gurjeevjohal5459
    @gurjeevjohal5459 Год назад +1

    You're videos are so helpful, one 5 minute video is worth 6 hours reading a chapter in a book. Please can you do some videos or a playlist on design patterns. Thanks!

  • @MTB_Bay_Area
    @MTB_Bay_Area Год назад +1

    Maybe HashMap takes longer because I the calculation of the hash? To get to a value HashMap first calculate hash value, and only then go to the location.

  • @EdgarRamirez-ry2je
    @EdgarRamirez-ry2je 9 месяцев назад

    More videos like this with solutions for diferent letcode, hackerank problems this is very much usefull to improve skills, you explain as a master

  • @EdgarRamirez-ry2je
    @EdgarRamirez-ry2je Год назад +1

    Excelent explication of a leetcode coding challenge, thanks i hope to see more videos of coding challenges medium and hard

  • @zerkinanastya4410
    @zerkinanastya4410 Год назад

    Definitely one of the best explanations or just the best, starting from the basic one (brute force) just to kick off and let viewers like me grasp the idea before jumping to more complex solutions. Thank you!

  • @diegosuarezgarcia248
    @diegosuarezgarcia248 Год назад +1

    I'm assuming this last approach is faster because the window defined by 'left' and 'right' never ends up being long enough to operate less efficiently than when using a map. I mean, Imagine the 5*10^4 (50000) String where ALL its characters are different (this means, maxLength would be 50000). Everytime you call 'indexOf()', Java is basically running a O(N) algorithm, where N is the length of the window we use. Said window starts with length 0, it's increased each loop and its length ends up being 50000. We have a complexity O(50000!), don't we? For this kind of scenario, unless I am mistaken, using a map is a way better choice.

  • @zoflax
    @zoflax Год назад +1

    this series is actually so good.

  • @kafychannel
    @kafychannel Год назад +1

    Great explanation,thank you !

  • @markmuyot2436
    @markmuyot2436 5 месяцев назад

    I liked your videos, you made them all easy to grasp! please do more leetcodes tutorials and data structures and algorithms content

  • @kevolala
    @kevolala 9 месяцев назад

    This is the most detailed and accurate explanation of this problem I've seen. 👍

  • @sheko4515
    @sheko4515 6 месяцев назад

    Can you please do more videos like this as you explain it in a great way.

  • @Verdarin
    @Verdarin Год назад +1

    I know this is a bit late, but I believe Map is quite slow in runtime from what I heard and so it doesnt give off the best speed, Map is a great to use if you dont care much about speed as much as you want cleaner and simple code (tho run time is and should be priority)

  • @zainahmed755
    @zainahmed755 Год назад +1

    Best channel ever ! , please keep going with the leatcode series

  • @foratzoabi1311
    @foratzoabi1311 7 месяцев назад

    Hey John! First of all thanks for the amazing video!
    Short answer for why indexOf is faster in this case:
    It is simply because in this case it has an O(1) runtime, how? here is how:
    Before you slide your right pointer to the right you have already made sure that this substring has different characters, which in the worst case will be 24 characters long. Since you know it will never be longer than 24 characters, or 34 if numbers are included in the string, then it is constant time, because no matter how big your string will be, it will be in the worst case that maximum substring :D so it is related to the valid substring and not to the input! :D
    And since the map indeed has access and write time of O(1) it still has an overhead for hash calculation and storing and etc... which take more operations / time than indexOf in that case, but since none of them is related to n, the one with the shorter/faster operations wins :D
    I hope that was helpful!

  • @Shivam-gh2mq
    @Shivam-gh2mq Год назад

    I watched till 25:32 and was able to come up with a solution. Thanks for this amazing explanation!

  • @jordanT_alker
    @jordanT_alker 3 месяца назад

    Interesting!
    I am very honest with myself, I am not seeing the full picture when it occurs to recursion;
    However, I did grasp the idea of the "quicksort" method a bit better, not 100% but we are learning.
    I can see this is almost similar to an array.

  • @thelazymim9338
    @thelazymim9338 Год назад

    Best Explanation. Please make videos on All LeetCode's 145 top interview questions. You will be immortal for the Computer Programmers Community.

  • @Soromeister
    @Soromeister Год назад +1

    Love the series and quite a nice explanation on the different approaches, although the last one is confusing for me.

  • @otisopoku37
    @otisopoku37 8 месяцев назад

    Your explanations are very good. More leetcode!!!!!!!!!

  • @deepakroy3476
    @deepakroy3476 5 месяцев назад

    You make programming easy and simple

  • @logesh9141
    @logesh9141 Год назад +1

    hi John,
    The way of explanation which you are giving is excellent.
    Since, I am mostly working JAVA. You videos are very mich helpful for me to achieve greater heights in my life.
    I mostly use ECLIPSE for my Java Projects. If possible please guide me in using Intellij with each and every shortcuts.
    Thanks in Advance,
    Logesh

  • @sankalp.m.patilsmp1472
    @sankalp.m.patilsmp1472 Год назад +1

    this channel has wonderful content, and easy to understand explaination.

  • @psg9278
    @psg9278 Год назад +1

    Thanks Please do more

  • @swagatpandak7325
    @swagatpandak7325 Год назад +1

    Continue this series in java please.Thanks john.

    • @CostaKazistov
      @CostaKazistov Год назад

      Yes, please!
      Most LeetCode videos out there are either Python or C++
      Definitely want to see more LeetCode walkthroughs in Java (or Kotlin)

  • @olyamychko4315
    @olyamychko4315 Год назад +1

    Thanks for great explanations!

  • @pedroalves5482
    @pedroalves5482 Год назад

    Hi, first time watching your videos, and I love the clarity of your explanation.
    I think I figured out the reason of Map been more slowest than last example, when you use the hash map you as writing and updating the data, to have the current letter position. On the other side the s.index only search if exist this value.

  • @nicovogel9924
    @nicovogel9924 Год назад +2

    I would never thought of HashMap is it possible to do the same thing with a list just if list.contains(a) list.remove(a) list.append(a). Could you pls make a video about how fast all these datastructures in comparison are.
    you can explain very good :)

  • @xeanluxcrille6847
    @xeanluxcrille6847 Год назад +2

    I'm not entirely sure, but the answer to the difference in time complexity might be in how indexOf is implemented in the first place. I'm not an expert at all, but what if the indexOf method itself already utilizes the exact same Map implementation? Meaning, your Map implementation could be a duplicate of indexOf(), except indexOf() doesn't have the extra steps within the implementations of contains() and get() because it's already encapsulated in core Java. I'm just guessing here, of course. Pretty sure I could be wrong.

  • @laharibasu9731
    @laharibasu9731 Год назад

    Can you please make more of these leetcode java solutions videos. They are of great help and you make us understand wonderfully.

  • @markmuyot2436
    @markmuyot2436 10 месяцев назад

    Hi John I like how you present your leetcode solutions, so easy to follow and understand. Hope to see more of this or if you have anothe platform teaching leetcode problems , I would be happy to know.. Thank you

  • @saeednoshadi3922
    @saeednoshadi3922 Год назад +1

    This playlist is amazing, Why don't you continue this series of videos?

  • @ashashankar29
    @ashashankar29 Год назад

    Excellent explanation and solution. I clearly understood the problem and solution. thank you

  • @SaifaldeenSAH
    @SaifaldeenSAH Год назад

    The best explaining ever, hoping to make more videos plz or DS and Algo videos. Thank you.

  • @rcciit9226
    @rcciit9226 11 месяцев назад

    Wow so easy to learn and understand , you have a new student sir.

  • @ArunKumar-jk5pq
    @ArunKumar-jk5pq Год назад

    This is awesome way of teaching! Thanks John!

  • @Laughing_india_
    @Laughing_india_ Год назад

    love from india❤️ Pls upload a problem on daily basis

  • @dadaboymasharipov2653
    @dadaboymasharipov2653 Год назад +1

    Hi there!! I really like your videos so much you make them easy to understand!! I want to ask you something can you recommend a book or books to improve our problem solving skill and to learn data structures

  • @jonathanhawkins9147
    @jonathanhawkins9147 Год назад

    Yum just a subscriber with the initial sponsor ad

  • @benjaminandersonii9842
    @benjaminandersonii9842 Год назад +1

    The reason for the final solution being faster is because while hash tables have "constant" lookup time it still takes time. Depending on the hashing function and the initial size of the hashmap the lookup, add, and resize functions may be more time consuming than just linearly looking through an array of characters. Especially if the hashing function has division, because of how bad computers are at it. So rather than your hashmap having O(1) time complexity for lookup its probably more like O(100) which is potentially smaller than the size of n.
    Sorry for the long rambling answer, but yeah hashmaps are great, if you know how the data is being put into them. They also take up a *bunch* of space, so finding an algorithm that is similar in functionality, but doesn't use them is always the way to go.

    • @vedantjha2327
      @vedantjha2327 Год назад

      True, just to add your answer, hashmap has constant time complexity in average case, but O(n) in worst case. So it's not 100% perfect n effective in all cases

  • @antonignatenko7776
    @antonignatenko7776 Год назад

    if possible more videos like this, especially interested in thought process behind solutioon

  • @user-kuzya2023
    @user-kuzya2023 Год назад

    Спасибо Джон. Продолжайте и дальше радовать нас своими видео. Thanks John. Continue to delight us with your videos

  • @odaia.7519
    @odaia.7519 Год назад +1

    I think maps are very performant in java, so it's not because of the map functions. What i think it's because of initialize an object of it and this takes time. I saw this while measuring a function using map in my performance project.

  • @Tibetan-experience
    @Tibetan-experience Год назад

    Thanks John. Always putting these awesome videos.

  • @yedum321
    @yedum321 Год назад

    I've been binging your videos. I feel like God sent you to me. Thank you

  • @VinuCP
    @VinuCP 10 месяцев назад

    Thanks John for awesome video and great explanation. For the Map solution wouldn't it also help to add an exit condition to break the loop
    if (maxLength > input.length() - right + 1) - so we need not iterate the remaining characters in the input.

  • @shakilansari8967
    @shakilansari8967 Год назад

    Lots of love from India...

  • @bendror8302
    @bendror8302 Год назад +1

    wow thanks 🙏

  • @rupambhattacharyya780
    @rupambhattacharyya780 Год назад

    Long story short, here two algorithms are used ..1)sliding window algorithm of variable size
    2) 2 pointer approach

  • @bendror8302
    @bendror8302 Год назад

    Nice to learn from you John, can you add more solutions from LeetCode?

  • @NiChOlAs-gw7iw
    @NiChOlAs-gw7iw Год назад

    wow pls, do more Leetcode exercise explanations!

  • @158thavashankarrajakc9
    @158thavashankarrajakc9 Год назад

    need more tutorials please :) thank you!

  • @germimonte
    @germimonte Год назад +1

    as for the better time, my best guess is a combination of the sample data and the relatively massive overhead of the default HashMap implementation, using arrays to implement your own map SHOULD in theory produce better results, I'll test it later. Or you could just pass 127 as the initial capacity of the map?

  • @aneeshdixit4
    @aneeshdixit4 Год назад

    Thank you for the amazing and clear explaination.
    Can you explain this next? 992. Subarrays with K Different Integers.

  • @rishiraj2548
    @rishiraj2548 Год назад +2

    Name of Map:
    seenChars

  • @bekuostudio
    @bekuostudio 9 месяцев назад

    Thanks for the clear explanation. I'm struggling with tech interviews. How am I supposed to complete a challenge in a short time? I just got stuck in the last one. I'm trying so hard to understand. I've been practicing LeetCode exercises, but there's always something tricky, and I've never seen anything similar before. It's so frustrating

  • @bartoszjozwicki4541
    @bartoszjozwicki4541 Год назад +1

    Hello John, another great video. That is my solution (better than brute force, worse than fast solution but probably quite easy to understand), thanks for your work!
    class Solution {
    public int lengthOfLongestSubstring(String s) {
    Integer currentRun = 0;
    Integer longestSoFar = 0;
    char[] arr = s.toCharArray();
    HashMap hM = new HashMap();
    for(int i = 0; i < arr.length; i++)
    {
    if(hM.containsKey(arr[i]))
    {
    currentRun = hM.size();
    if(longestSoFar < currentRun)
    {
    longestSoFar = currentRun;
    }
    i = hM.get(arr[i]);
    hM.clear();
    }
    else
    {
    hM.put(arr[i], i);
    }
    }

    currentRun = hM.size();
    if(longestSoFar < currentRun)
    {
    longestSoFar = currentRun;
    }
    return (int)longestSoFar;
    }
    }

  • @rameezalam1968
    @rameezalam1968 Год назад

    Hi Johnny sin, good to see in as a software developer role as well

  • @hendhasnaoui9419
    @hendhasnaoui9419 Год назад

    i'm really impressed 👍👍. keep on going 👏👏👏

  • @quandingleberry445
    @quandingleberry445 Год назад

    Great video, also I think the last part might be bc of best case scenario

  • @chrisjames278
    @chrisjames278 Год назад

    great video. Keep them coming!

  • @adriangonzalez6564
    @adriangonzalez6564 Год назад

    Awesome video!!!
    You are by far the best coding tecaher i could find in internet.
    Coud you do a video explaining how to read a csv file in Java?? It would be great.
    Really very good content, keep doing it

  • @ozzDeveveloperOpenForWork
    @ozzDeveveloperOpenForWork Год назад

    perfect. you have more question answer videos, like a playlist of them? Thanks

  • @MTB_Bay_Area
    @MTB_Bay_Area Год назад

    for the version that uses the HashMap, I would suggest to have an else. when we are in the "if contains" we are always shortening the substring and hence no need to update the max.

  • @DominikGuzowski
    @DominikGuzowski Год назад

    The second solution is definitely better than the first one than the map purely because our domain is so small, so all of the map operations while "constant" probably take a tad bit longer than this linear search, but again this is just due to the domain. If this was not strings but instead an array of numbers, where the domain can be much larger, the map would probably outperform this approach, though that is just a guess.

  • @tiyoo6961
    @tiyoo6961 Год назад

    Thank you

  • @hasibulhasansiju
    @hasibulhasansiju Год назад

    Want more of this

  • @arthurmagamedov3179
    @arthurmagamedov3179 Год назад

    Thanks John for the amazing video!! As for maps - what is the low level implementation of maps in JVM code? I mean, does it calculate the hash for the key when put or get methods are invoked? If it does, then adding or reading keys will be quite expensive , and explains why indexOf works faster.

  • @james-ansley
    @james-ansley Год назад

    The max possible substring is bounded by the number of possible characters in the string, m, which given the problem constraints seems to be at most ~100ish. And, I would imagine on average the actual distance between the left and right pointers will be much less than this. This then means you are *effectively* comparing two linear solutions (even though the indexOf solution is technically nm - m is small).
    I would imagine that for small values of m the simplicity of linearly looping through a few characters of a string would be much faster than map lookups and manipulation. It would be interesting to see if the map-based solution would surpass the indexOf solution by increasing m, by, for example, using all UTF-8 chars.

    • @CodingWithJohn
      @CodingWithJohn  Год назад +2

      Well the problem states that the input string may be up to 50,000 characters long. But I do think it's a good insight that the max length of the longest substring is bounded by the number of unique characters in the character set being used. In this case it says "English letters, digits, symbols and spaces." I'd have to add all those up to be sure, but let's say it's maybe 100, which may be a big reason the map solution is overkill at this level

  • @alexanderkomanov4151
    @alexanderkomanov4151 Год назад

    AMAZING!

  • @_Anna_Nass_
    @_Anna_Nass_ Год назад

    More leetcode problems!!! I like this style of video 🧌

  • @rtphi
    @rtphi Год назад +2

    I tried your 2nd solution but instead of map i used int[127]. Runtime was 2ms, faster than 100%... But memory usage was 44.2MB, less than 74%...

    • @CodingWithJohn
      @CodingWithJohn  Год назад

      Nice! It could be that for the inputs they provide just iterating through a simple array like that is faster.

    • @jonathanhallstrom
      @jonathanhallstrom Год назад

      @@CodingWithJohn There will be no iterating through the array, just indexing the array with the characters the same way as you did with your Map, except using some sentinel value (such as -1) as a stand in for a key not being in the array.
      Edit:
      Example code (2ms runtime):
      class Solution {
      public int lengthOfLongestSubstring(String s) {
      int[] idx = new int[128]; // 7 bit ascii
      for (int i = 0; i < idx.length; ++i)
      idx[i] = -1;
      int ans = 0;
      for (int start = 0, end = 0; end < s.length(); ++end) {
      start = Math.max(start, idx[s.charAt(end)] + 1);
      ans = Math.max(ans, end - start + 1);
      idx[s.charAt(end)] = end;
      }
      return ans;
      }
      }

  • @helcium2022
    @helcium2022 2 месяца назад

    More leetcode examples please

  • @ananthukkumar987
    @ananthukkumar987 Год назад

    traversedCharacters would be a meaningful one.